commit:     0a0559d00cf47162ff0e94c9189a0a2104624c48
Author:     Nicolas Bock <nicolasbock <AT> gentoo <DOT> org>
AuthorDate: Mon Aug 17 12:31:39 2015 +0000
Commit:     Nicolas Bock <nicolasbock <AT> gentoo <DOT> org>
CommitDate: Mon Aug 17 18:43:26 2015 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=0a0559d0

sci-physics/lammps: Version bump.

Also addressed Bug 557208 and added a default value for memalign.

Package-Manager: portage-2.2.20.1

 sci-physics/lammps/Manifest               |   1 +
 sci-physics/lammps/lammps-20150810.ebuild | 267 ++++++++++++++++++++++++++++++
 sci-physics/lammps/metadata.xml           |   2 +-
 3 files changed, 269 insertions(+), 1 deletion(-)

diff --git a/sci-physics/lammps/Manifest b/sci-physics/lammps/Manifest
index 67afd43..db8ec1e 100644
--- a/sci-physics/lammps/Manifest
+++ b/sci-physics/lammps/Manifest
@@ -1,3 +1,4 @@
+DIST lammps-10Aug15.tar.gz 87890369 SHA256 
450a765f94b70a6f38637854f1d7496dca98d359414c527f8de99bed1fdd94d2 SHA512 
fc395cf7e59de7e71bad64e2500224d33ff0f76bb79530fdcde5ec9879b91c332d1421a25e5d5bb9cc47a55745e760d01b2ac8ad29f9e71c8a90a0ace9212618
 WHIRLPOOL 
3f50513137283f4deb9b6a2c13a7ba63814b0ddd59d33e428fba9d3f94f61baa1b3b9d9d080982453a7828d2a98e619cded4d27716fd165db595832a157c9f6b
 DIST lammps-10Feb15.tar.gz 62912048 SHA256 
59373e9b5592f7b697a144bbce1fb742726e03536b7bb355dac7a9e013ddf9b8 SHA512 
a7804377a23f03f338bdaf443439dffcdc52293b4c45e6369b340a1107510fed0b8a198e3b5afcff2e04e109985b52ee62e7b28276697bae37ac6f783d1ab9f2
 WHIRLPOOL 
09f29cadf8b072d388abe45ec219341d2a14a6c9cc9e4010a0f7945e930e9984738f7837748d117ab95ca76ce0c8d9160fe88dcec17e8d21b81f385dec8f7005
 DIST lammps-15May15.tar.gz 63835027 SHA256 
0233ea98c7d77d31bd0a538bb674c0ee8f000f1d0ee1b8c049072873192aa228 SHA512 
a23c16b98117590b15ca7662b878fb2f76ec41399c329c98deb48e28a0ffce293443269513a96c2503389894b598787b19dadc210d4b4dbc6a7432caf633e7d1
 WHIRLPOOL 
4c4edfd772bbf534e42fc43e1feaf3b8f76e74c58ec1e985e3c29ee0d8e64aa8c501b8e45e078643409c320a1d834b0d5eb699e7d1ec29df06be0126d12492f1
 DIST lammps-16Apr15.tar.gz 63842472 SHA256 
65aecf6f25a055734ef113890a86ecbf7f8478105238c507e5f9bcbeb657bc99 SHA512 
95639145db66e76bd27a865849dc0ad15d3920f7ca9f1fb9a426e457376d0c939c57440e89fa6903d1989ca5e5c6c97d8d283928e1dbf33dd94ba88dbb05a252
 WHIRLPOOL 
422f6814093f22820cfd8fada1d97735c1a8f0388b34e6bad49e361e411b254ea89e6bf7afa8390c0cba1371a6d038fa84cf93583568c5223e42d95210f13515

diff --git a/sci-physics/lammps/lammps-20150810.ebuild 
b/sci-physics/lammps/lammps-20150810.ebuild
new file mode 100644
index 0000000..1a244c8
--- /dev/null
+++ b/sci-physics/lammps/lammps-20150810.ebuild
@@ -0,0 +1,267 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+PYTHON_COMPAT=( python{2_7,3_3} )
+
+inherit eutils flag-o-matic fortran-2 multilib python-r1
+
+convert_month() {
+       case $1 in
+               01) echo Jan
+                       ;;
+               02) echo Feb
+                       ;;
+               03) echo Mar
+                       ;;
+               04) echo Apr
+                       ;;
+               05) echo May
+                       ;;
+               06) echo Jun
+                       ;;
+               07) echo Jul
+                       ;;
+               08) echo Aug
+                       ;;
+               09) echo Sep
+                       ;;
+               10) echo Oct
+                       ;;
+               11) echo Nov
+                       ;;
+               12) echo Dec
+                       ;;
+               *)  echo unknown
+                       ;;
+       esac
+}
+
+MY_P=${PN}-$((10#${PV:6:2}))$(convert_month ${PV:4:2})${PV:2:2}
+
+DESCRIPTION="Large-scale Atomic/Molecular Massively Parallel Simulator"
+HOMEPAGE="http://lammps.sandia.gov/";
+SRC_URI="http://lammps.sandia.gov/tars/${MY_P}.tar.gz";
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="doc examples gzip lammps-memalign mpi python static-libs"
+
+DEPEND="
+       mpi? (
+               virtual/blas
+               virtual/lapack
+               virtual/mpi
+       )
+       gzip? ( app-arch/gzip )
+       sci-libs/voro++
+       python? ( ${PYTHON_DEPS} )
+       "
+RDEPEND="${DEPEND}"
+
+REQUIRED_USE="python? ( ${PYTHON_REQUIRED_USE} )"
+
+S="${WORKDIR}/${MY_P}"
+
+lmp_emake() {
+       local LAMMPS_INCLUDEFLAGS
+       LAMMPS_INCLUDEFLAGS="$(usex gzip '-DLAMMPS_GZIP' '')"
+       LAMMPS_INCLUDEFLAGS+="$(usex lammps-memalign ' -DLAMMPS_MEMALIGN=64' 
'')"
+
+       # The lammps makefile uses CC to indicate the C++ compiler.
+       emake \
+               ARCHIVE=$(tc-getAR) \
+               CC=$(usex mpi "mpic++" "$(tc-getCXX)") \
+               F90=$(usex mpi "mpif90" "$(tc-getFC)") \
+               LINK=$(usex mpi "mpic++" "$(tc-getCXX)") \
+               CCFLAGS="${CXXFLAGS}" \
+               F90FLAGS="${FCFLAGS}" \
+               LINKFLAGS="${LDFLAGS}" \
+               LMP_INC="${LAMMPS_INCLUDEFLAGS}" \
+               MPI_INC=$(usex mpi "" "-I../STUBS") \
+               MPI_PATH=$(usex mpi "" "-L../STUBS") \
+               MPI_LIB=$(usex mpi "" "-lmpi_stubs") \
+               user-atc_SYSLIB="$(usex mpi "$($(tc-getPKG_CONFIG) --libs blas) 
$($(tc-getPKG_CONFIG) --libs lapack)" '')"\
+               "$@"
+}
+
+lmp_activate_packages() {
+       # Build packages
+       lmp_emake -C src yes-asphere
+       lmp_emake -C src yes-body
+       lmp_emake -C src yes-class2
+       lmp_emake -C src yes-colloid
+       lmp_emake -C src yes-coreshell
+       lmp_emake -C src yes-dipole
+       lmp_emake -C src yes-fld
+       #lmp_emake -C src yes-gpu
+       lmp_emake -C src yes-granular
+       # Need OpenKIM external dependency.
+       #lmp_emake -C src yes-kim
+       # Need Kokkos external dependency.
+       #lmp_emake -C src yes-kokkos
+       lmp_emake -C src yes-kspace
+       lmp_emake -C src yes-manybody
+       lmp_emake -C src yes-mc
+       lmp_emake -C src yes-meam
+       lmp_emake -C src yes-misc
+       lmp_emake -C src yes-molecule
+       #lmp_emake -C src yes-mpiio
+       lmp_emake -C src yes-opt
+       lmp_emake -C src yes-peri
+       lmp_emake -C src yes-poems
+       lmp_emake -C src yes-qeq
+       lmp_emake -C src yes-reax
+       lmp_emake -C src yes-replica
+       lmp_emake -C src yes-rigid
+       lmp_emake -C src yes-shock
+       lmp_emake -C src yes-snap
+       lmp_emake -C src yes-srd
+       lmp_emake -C src yes-voronoi
+       lmp_emake -C src yes-xtc
+
+       if use mpi; then
+               lmp_emake -C src yes-user-atc
+       fi
+       lmp_emake -C src yes-user-eff
+       lmp_emake -C src yes-user-fep
+       use mpi && lmp_emake -C src yes-user-lb
+       lmp_emake -C src yes-user-phonon
+       lmp_emake -C src yes-user-sph
+}
+
+lmp_build_packages() {
+       lmp_emake -C lib/meam -j1 -f Makefile.gfortran
+       lmp_emake -C lib/poems -f Makefile.g++
+       lmp_emake -C lib/reax -j1 -f Makefile.gfortran
+       use mpi && lmp_emake -C lib/atc -f Makefile.g++
+}
+
+lmp_clean_packages() {
+       lmp_emake -C lib/meam -f Makefile.gfortran clean
+       lmp_emake -C lib/poems -f Makefile.g++ clean
+       lmp_emake -C lib/reax -f Makefile.gfortran clean
+       use mpi && lmp_emake -C lib/atc -f Makefile.g++ clean
+}
+
+src_prepare() {
+       # Fix inconsistent use of SHFLAGS.
+       sed -i \
+               -e 's:voronoi_SYSINC\s\+=.*$:voronoi_SYSINC = 
-I/usr/include/voro++:' \
+               -e 's:voronoi_SYSPATH\s\+=.*$:voronoi_SYSPATH =:' \
+               lib/voronoi/Makefile.lammps || die
+
+       # Fix missing .so name.
+       sed -i \
+               -e 's:SHLIBFLAGS\s\+=\s\+:SHLIBFLAGS = 
-Wl,-soname,liblammps.so.0 :' \
+               src/MAKE/Makefile.serial || die
+
+       # Fix makefile in tools.
+       sed -i \
+               -e 's:g++:$(CXX) $(CXXFLAGS):' \
+               -e 's:gcc:$(CC) $(CCFLAGS):' \
+               -e 's:ifort:$(FC) $(FCFLAGS):' \
+               tools/Makefile || die
+
+       # Patch python.
+       epatch "${FILESDIR}/lammps-python3.patch"
+       epatch "${FILESDIR}/python-shebang.patch"
+}
+
+src_compile() {
+       # Fix atc...
+       append-cxxflags -I../../src
+
+       # Acticate packages.
+       elog "Activating lammps packages..."
+       lmp_activate_packages
+
+       # Compile stubs for serial version.
+       use mpi || lmp_emake -C src mpi-stubs
+
+       elog "Building packages..."
+       lmp_build_packages
+
+       if use static-libs; then
+               # Build static library.
+               elog "Building static library..."
+               lmp_emake -C src mode=lib serial
+       fi
+
+       # Clean out packages (that's not done by the build system with the clean
+       # target), so we can rebuild the packages with -fPIC.
+       elog "Cleaning packages..."
+       lmp_clean_packages
+
+       # The build system does not rebuild the packages with -fPIC, adding flag
+       # manually.
+       append-cxxflags -fPIC
+       append-fflags -fPIC
+
+       # Compile stubs for serial version.
+       use mpi || lmp_emake -C src mpi-stubs
+
+       elog "Building packages..."
+       lmp_build_packages
+
+       # Build shared library.
+       elog "Building shared library..."
+       lmp_emake -C src mode=shlib serial
+
+       # Compile main executable. The shared library is always built, and
+       # mode=shexe is simply a way to re-use the object files built in the
+       # "shlib" step when linking the executable. The executable is not 
actually
+       # using the shared library. If we have built the static library, then we
+       # link that into the executable.
+       elog "Linking executable..."
+       if use static-libs; then
+               lmp_emake -C src mode=exe serial
+       else
+               lmp_emake -C src mode=shexe serial
+       fi
+
+       # Compile tools.
+       elog "Building tools..."
+       lmp_emake -C tools binary2txt chain data2xmovie micelle2d
+}
+
+src_install() {
+       use static-libs && newlib.a src/liblammps_serial.a liblammps.a
+       newlib.so src/liblammps_serial.so liblammps.so.0.0.0
+       dosym liblammps.so.0.0.0 /usr/$(get_libdir)/liblammps.so
+       dosym liblammps.so.0.0.0 /usr/$(get_libdir)/liblammps.so.0
+       newbin src/lmp_serial lmp
+       dobin tools/binary2txt
+       dobin tools/chain
+       dobin tools/data2xmovie
+       dobin tools/micelle2d
+       # Don't forget to add header files of optional packages as they are 
added
+       # to this ebuild. There may also be .mod files from Fortran based
+       # packages.
+       insinto "/usr/include/${PN}"
+       doins -r src/*.h lib/meam/*.mod
+
+       local LAMMPS_POTENTIALS="usr/share/${PN}/potentials"
+       insinto "/${LAMMPS_POTENTIALS}"
+       doins potentials/*
+       echo "LAMMPS_POTENTIALS=${EROOT}${LAMMPS_POTENTIALS}" > 99lammps
+       doenvd 99lammps
+
+       # Install python script.
+       use python && python_foreach_impl python_domodule python/lammps.py
+
+       if use examples; then
+               local LAMMPS_EXAMPLES="/usr/share/${PN}/examples"
+               insinto "${LAMMPS_EXAMPLES}"
+               doins -r examples/*
+       fi
+
+       dodoc README
+       if use doc; then
+               dodoc doc/Manual.pdf
+               dohtml -r doc/*
+       fi
+}

diff --git a/sci-physics/lammps/metadata.xml b/sci-physics/lammps/metadata.xml
index 5d67bcd..bd12f29 100644
--- a/sci-physics/lammps/metadata.xml
+++ b/sci-physics/lammps/metadata.xml
@@ -18,7 +18,7 @@
   <use>
     <flag name="lammps-memalign">Enables the use of the posix_memalign()
                        call instead of malloc() when large chunks or memory 
are allocated
-                       by LAMMPS</flag>
+                       by LAMMPS. Aliengnment is on 16 byte boundaries.</flag>
   </use>
   <herd>sci-physics</herd>
   <maintainer>

Reply via email to